summaryrefslogtreecommitdiff
path: root/dev-java
diff options
context:
space:
mode:
authorAlex Xu (Hello71) <alex_y_xu@yahoo.ca>2020-08-15 09:43:10 -0400
committerAlex Xu (Hello71) <alex_y_xu@yahoo.ca>2020-08-15 09:43:10 -0400
commit7c302914f5b566df48488e3959552feae1c1cab1 (patch)
treeac604cd215b1137eadbeb836fc70ba08c9a3a5ba /dev-java
parent139072db7ac4d30ba74a372a793bd78110a4e936 (diff)
downloadgentoo-overlay-7c302914f5b566df48488e3959552feae1c1cab1.tar.xz
gentoo-overlay-7c302914f5b566df48488e3959552feae1c1cab1.zip
dev-java/openj9-openjdk: add 9999, various fixes
Diffstat (limited to 'dev-java')
-rw-r--r--dev-java/openj9-openjdk/files/openj9-j9utf8-fam.patch26
-rw-r--r--dev-java/openj9-openjdk/files/openj9-openjdk-14.env.sh16
-rw-r--r--dev-java/openj9-openjdk/files/openj9-openjdk.env.sh (renamed from dev-java/openj9-openjdk/files/openj9-openjdk-11.env.sh)0
-rw-r--r--dev-java/openj9-openjdk/openj9-openjdk-11.0.21.0.ebuild94
-rw-r--r--dev-java/openj9-openjdk/openj9-openjdk-14.0.21.0.ebuild94
-rw-r--r--dev-java/openj9-openjdk/openj9-openjdk-14.9999.ebuild343
-rw-r--r--dev-java/openj9-openjdk/openj9-openjdk-15.9999.ebuild341
7 files changed, 805 insertions, 109 deletions
diff --git a/dev-java/openj9-openjdk/files/openj9-j9utf8-fam.patch b/dev-java/openj9-openjdk/files/openj9-j9utf8-fam.patch
deleted file mode 100644
index f45a539..0000000
--- a/dev-java/openj9-openjdk/files/openj9-j9utf8-fam.patch
+++ /dev/null
@@ -1,26 +0,0 @@
-diff --git a/runtime/cfdumper/romdump.c b/runtime/cfdumper/romdump.c
-index 5040c2c25..1cfcd36c7 100644
---- a/runtime/cfdumper/romdump.c
-+++ b/runtime/cfdumper/romdump.c
-@@ -154,7 +154,7 @@ addRegion(J9Pool *regionPool, UDATA offset, UDATA length, UDATA type, const char
- static UDATA
- getUTF8Length(J9UTF8 *utf8)
- {
-- UDATA length = sizeof(J9UTF8) + J9UTF8_LENGTH(utf8) - sizeof(J9UTF8_DATA(utf8));
-+ UDATA length = sizeof(J9UTF8) + J9UTF8_LENGTH(utf8);
- if (length & 1) {
- length++;
- }
-diff --git a/runtime/oti/j9nonbuilder.h b/runtime/oti/j9nonbuilder.h
-index c5705188d..e9babe227 100644
---- a/runtime/oti/j9nonbuilder.h
-+++ b/runtime/oti/j9nonbuilder.h
-@@ -3219,7 +3219,7 @@ typedef struct J9ClassLoader {
-
- typedef struct J9UTF8 {
- U_16 length;
-- U_8 data[2];
-+ U_8 data[];
- } J9UTF8;
-
- typedef struct J9ROMClass {
diff --git a/dev-java/openj9-openjdk/files/openj9-openjdk-14.env.sh b/dev-java/openj9-openjdk/files/openj9-openjdk-14.env.sh
deleted file mode 100644
index 5aac9c7..0000000
--- a/dev-java/openj9-openjdk/files/openj9-openjdk-14.env.sh
+++ /dev/null
@@ -1,16 +0,0 @@
-# Copyright 1999-2018 Gentoo Authors
-# Distributed under the terms of the GNU General Public License v2
-
-VERSION="OpenJDK ${SLOT} with OpenJ9 ${OPENJ9_PV}"
-JAVA_HOME="${EPREFIX}/usr/$(get_libdir)/${PN}-${SLOT}"
-JDK_HOME="${EPREFIX}/usr/$(get_libdir)/${PN}-${SLOT}"
-JAVAC="\${JAVA_HOME}/bin/javac"
-PATH="\${JAVA_HOME}/bin"
-ROOTPATH="\${JAVA_HOME}/bin"
-LDPATH="\${JAVA_HOME}/lib/:\${JAVA_HOME}/lib/server/"
-MANPATH=""
-PROVIDES_TYPE="JDK JRE"
-PROVIDES_VERSION="${SLOT}"
-BOOTCLASSPATH=""
-GENERATION="2"
-ENV_VARS="JAVA_HOME JDK_HOME JAVAC PATH ROOTPATH LDPATH MANPATH"
diff --git a/dev-java/openj9-openjdk/files/openj9-openjdk-11.env.sh b/dev-java/openj9-openjdk/files/openj9-openjdk.env.sh
index 5aac9c7..5aac9c7 100644
--- a/dev-java/openj9-openjdk/files/openj9-openjdk-11.env.sh
+++ b/dev-java/openj9-openjdk/files/openj9-openjdk.env.sh
diff --git a/dev-java/openj9-openjdk/openj9-openjdk-11.0.21.0.ebuild b/dev-java/openj9-openjdk/openj9-openjdk-11.0.21.0.ebuild
index 15f7bf2..56dd85d 100644
--- a/dev-java/openj9-openjdk/openj9-openjdk-11.0.21.0.ebuild
+++ b/dev-java/openj9-openjdk/openj9-openjdk-11.0.21.0.ebuild
@@ -12,11 +12,18 @@ FREEMARKER_PV=2.3.30
DESCRIPTION="Open source implementation of the Java programming language"
HOMEPAGE="https://openjdk.java.net"
-SRC_URI="
- https://github.com/ibmruntimes/openj9-openjdk-jdk${SLOT}/archive/${OPENJ9_P}.tar.gz -> openj9-openjdk-jdk${SLOT}-${OPENJ9_P}.tar.gz
- https://github.com/eclipse/openj9/archive/${OPENJ9_P}.tar.gz -> ${OPENJ9_P}.tar.gz
- https://github.com/eclipse/openj9-omr/archive/${OPENJ9_P}.tar.gz -> openj9-omr-${OPENJ9_PV}.tar.gz
+if [[ ${OPENJ9_PV} == 9999 ]]; then
+ inherit git-r3
+ EGIT_REPO_URI="https://github.com/ibmruntimes/openj9-openjdk-jdk${SLOT}.git"
+ OPENJ9_EGIT_REPO_URI="https://github.com/eclipse/openj9.git"
+ OPENJ9_OMR_EGIT_REPO_URI="https://github.com/eclipse/openj9-omr.git"
+else
+ SRC_URI="
+ https://github.com/ibmruntimes/openj9-openjdk-jdk${SLOT}/archive/${OPENJ9_P}.tar.gz -> openj9-openjdk-jdk${SLOT}-${OPENJ9_P}.tar.gz
+ https://github.com/eclipse/openj9/archive/${OPENJ9_P}.tar.gz -> ${OPENJ9_P}.tar.gz
+ https://github.com/eclipse/openj9-omr/archive/${OPENJ9_P}.tar.gz -> openj9-omr-${OPENJ9_PV}.tar.gz
"
+fi
LICENSE="GPL-2"
KEYWORDS="~amd64"
@@ -72,10 +79,7 @@ DEPEND="
javafx? ( dev-java/openjfx:${SLOT}= )
|| (
virtual/jdk:${SLOT}
- dev-java/openj9-openjdk-bin:${SLOT}
- dev-java/openj9-openjdk:${SLOT}
- dev-java/openjdk-bin:${SLOT}
- dev-java/openjdk:${SLOT}
+ virtual/jdk:$((SLOT-1))
)
|| (
dev-java/freemarker-bin
@@ -90,7 +94,11 @@ PDEPEND="
REQUIRED_USE="javafx? ( alsa !headless-awt )"
-S="${WORKDIR}/openj9-openjdk-jdk${SLOT}-${OPENJ9_P}"
+if [[ ${OPENJ9_PV} == 9999 ]]; then
+ S="${WORKDIR}/openj9-openjdk-jdk${SLOT}"
+else
+ S="${WORKDIR}/openj9-openjdk-jdk${SLOT}-${OPENJ9_P}"
+fi
# The space required to build varies wildly depending on USE flags,
# ranging from 3GB to 16GB. This function is certainly not exact but
@@ -136,42 +144,58 @@ pkg_setup() {
fi
done
- if [[ ${MERGE_TYPE} != binary ]] && [[ -z ${JDK_HOME} ]]; then
- if has_version --host-root dev-java/openj9-openjdk:${SLOT}; then
- JDK_HOME=${EPREFIX}/usr/$(get_libdir)/openj9-openjdk-${SLOT}
- elif has_version --host-root dev-java/openj9-openjdk-bin:${SLOT}; then
- JDK_HOME=$(best_version --host-root dev-java/openj9-openjdk-bin:${SLOT})
- JDK_HOME=${JDK_HOME#*/}
- JDK_HOME=${EPREFIX}/opt/${JDK_HOME%-r*}
- elif has_version --host-root dev-java/openjdk:${SLOT}; then
- JDK_HOME=${EPREFIX}/usr/$(get_libdir)/openjdk-${SLOT}
- elif has_version --host-root dev-java/openjdk-bin:${SLOT}; then
- JDK_HOME=$(best_version --host-root dev-java/openjdk-bin:${SLOT})
- JDK_HOME=${JDK_HOME#*/}
- JDK_HOME=${EPREFIX}/opt/${JDK_HOME%-r*}
- else
- die "Build VM not found!"
+ if [[ ${MERGE_TYPE} != binary ]]; then
+ if [[ -z ${JDK_HOME} ]]; then
+ for slot in ${SLOT} $((SLOT-1)); do
+ for variant in openj9- ''; do
+ if has_version --host-root dev-java/${variant}openjdk:${slot}; then
+ JDK_HOME=${EPREFIX}/usr/$(get_libdir)/${variant}openjdk-${slot}
+ break
+ elif has_version --host-root dev-java/${variant}openjdk-bin:${slot}; then
+ JDK_HOME=$(best_version --host-root dev-java/${variant}openjdk-bin:${slot})
+ JDK_HOME=${JDK_HOME#*/}
+ JDK_HOME=${EPREFIX}/opt/${JDK_HOME%-r*}
+ break
+ fi
+ done
+ done
fi
+ [[ -n ${JDK_HOME} ]] || die "Build VM not found!"
export JDK_HOME
fi
}
+src_unpack() {
+ if [[ ${OPENJ9_PV} == 9999 ]]; then
+ EGIT_CHECKOUT_DIR=${S} git-r3_src_unpack
+ EGIT_CHECKOUT_DIR=openj9 EGIT_REPO_URI=${OPENJ9_EGIT_REPO_URI} git-r3_src_unpack
+ EGIT_CHECKOUT_DIR=openj9-omr EGIT_REPO_URI=${OPENJ9_OMR_EGIT_REPO_URI} git-r3_src_unpack
+ else
+ default
+ fi
+}
+
src_prepare() {
- ln -s ../openj9-${OPENJ9_P} openj9 || die
- ln -s ../openj9-omr-${OPENJ9_P} omr || die
+ if [[ ${OPENJ9_PV} == 9999 ]]; then
+ ln -s ../openj9 openj9 || die
+ ln -s ../openj9-omr omr || die
+ else
+ ln -s ../openj9-${OPENJ9_P} openj9 || die
+ ln -s ../openj9-omr-${OPENJ9_P} omr || die
+ fi
default
eapply -d openj9 -- "${FILESDIR}/openj9-make-jvmti-test-variables-static.patch"
- # broken verifier
- #eapply -d openj9 -- "${FILESDIR}/openj9-j9utf8-fam.patch"
eapply -d omr -- "${FILESDIR}/omr-omrstr-iconv-failure-overflow.patch"
eapply -d omr -- "${FILESDIR}/omr-fam.patch"
- sed -i -e '/^OPENJ9_SHA :=/s/:=.*/:= '${OPENJ9_P}/ \
- -e '/^OPENJ9_TAG :=/s/:=.*/:= '${OPENJ9_P}/ \
- -e '/^OPENJ9OMR_SHA :=/s/:=.*/:= '${OPENJ9_P}/ \
- closed/OpenJ9.gmk
+ if [[ ${OPENJ9_PV} != 9999 ]]; then
+ sed -i -e '/^OPENJ9_SHA :=/s/:=.*/:= '${OPENJ9_P}/ \
+ -e '/^OPENJ9_TAG :=/s/:=.*/:= '${OPENJ9_P}/ \
+ -e '/^OPENJ9OMR_SHA :=/s/:=.*/:= '${OPENJ9_P}/ \
+ closed/OpenJ9.gmk
+ fi
chmod +x configure || die
}
@@ -180,7 +204,8 @@ src_configure() {
# Work around stack alignment issue, bug #647954. in case we ever have x86
use x86 && append-flags -mincoming-stack-boundary=2
- # Work around -fno-common ( GCC10 default ), bug #713180
+ # https://bugs.openjdk.java.net/browse/JDK-8249792
+ # backported to 11.0.9
append-flags -fcommon
if has_version dev-java/freemarker; then
@@ -252,7 +277,6 @@ src_compile() {
JOBS=$(makeopts_jobs)
# https://github.com/ibmruntimes/openj9-openjdk-jdk14/issues/72
#LOG=debug
- CFLAGS_WARNINGS_ARE_ERRORS= # No -Werror
$(usex doc docs '')
$(usex jbootstrap bootcycle-images product-images)
)
@@ -294,7 +318,7 @@ src_install() {
# must be done before running itself
java-vm_set-pax-markings "${ddest}"
- use gentoo-vm && java-vm_install-env "${FILESDIR}"/${PN}-${SLOT}.env.sh
+ use gentoo-vm && java-vm_install-env "${FILESDIR}"/${PN}.env.sh
java-vm_revdep-mask
java-vm_sandbox-predict /dev/random /proc/self/coredump_filter
diff --git a/dev-java/openj9-openjdk/openj9-openjdk-14.0.21.0.ebuild b/dev-java/openj9-openjdk/openj9-openjdk-14.0.21.0.ebuild
index 3514ca7..4450730 100644
--- a/dev-java/openj9-openjdk/openj9-openjdk-14.0.21.0.ebuild
+++ b/dev-java/openj9-openjdk/openj9-openjdk-14.0.21.0.ebuild
@@ -12,11 +12,18 @@ FREEMARKER_PV=2.3.30
DESCRIPTION="Open source implementation of the Java programming language"
HOMEPAGE="https://openjdk.java.net"
-SRC_URI="
- https://github.com/ibmruntimes/openj9-openjdk-jdk${SLOT}/archive/${OPENJ9_P}.tar.gz -> openj9-openjdk-jdk${SLOT}-${OPENJ9_P}.tar.gz
- https://github.com/eclipse/openj9/archive/${OPENJ9_P}.tar.gz -> ${OPENJ9_P}.tar.gz
- https://github.com/eclipse/openj9-omr/archive/${OPENJ9_P}.tar.gz -> openj9-omr-${OPENJ9_PV}.tar.gz
+if [[ ${OPENJ9_PV} == 9999 ]]; then
+ inherit git-r3
+ EGIT_REPO_URI="https://github.com/ibmruntimes/openj9-openjdk-jdk${SLOT}.git"
+ OPENJ9_EGIT_REPO_URI="https://github.com/eclipse/openj9.git"
+ OPENJ9_OMR_EGIT_REPO_URI="https://github.com/eclipse/openj9-omr.git"
+else
+ SRC_URI="
+ https://github.com/ibmruntimes/openj9-openjdk-jdk${SLOT}/archive/${OPENJ9_P}.tar.gz -> openj9-openjdk-jdk${SLOT}-${OPENJ9_P}.tar.gz
+ https://github.com/eclipse/openj9/archive/${OPENJ9_P}.tar.gz -> ${OPENJ9_P}.tar.gz
+ https://github.com/eclipse/openj9-omr/archive/${OPENJ9_P}.tar.gz -> openj9-omr-${OPENJ9_PV}.tar.gz
"
+fi
LICENSE="GPL-2"
KEYWORDS="~amd64"
@@ -70,7 +77,10 @@ DEPEND="
x11-libs/libXt
x11-libs/libXtst
javafx? ( dev-java/openjfx:${SLOT}= )
- virtual/jdk:${SLOT}
+ || (
+ virtual/jdk:${SLOT}
+ virtual/jdk:$((SLOT-1))
+ )
|| (
dev-java/freemarker-bin
dev-java/freemarker
@@ -84,7 +94,11 @@ PDEPEND="
REQUIRED_USE="javafx? ( alsa !headless-awt )"
-S="${WORKDIR}/openj9-openjdk-jdk${SLOT}-${OPENJ9_P}"
+if [[ ${OPENJ9_PV} == 9999 ]]; then
+ S="${WORKDIR}/openj9-openjdk-jdk${SLOT}"
+else
+ S="${WORKDIR}/openj9-openjdk-jdk${SLOT}-${OPENJ9_P}"
+fi
# The space required to build varies wildly depending on USE flags,
# ranging from 3GB to 16GB. This function is certainly not exact but
@@ -130,42 +144,58 @@ pkg_setup() {
fi
done
- if [[ ${MERGE_TYPE} != binary ]] && [[ -z ${JDK_HOME} ]]; then
- if has_version --host-root dev-java/openj9-openjdk:${SLOT}; then
- JDK_HOME=${EPREFIX}/usr/$(get_libdir)/openj9-openjdk-${SLOT}
- elif has_version --host-root dev-java/openj9-openjdk-bin:${SLOT}; then
- JDK_HOME=$(best_version --host-root dev-java/openj9-openjdk-bin:${SLOT})
- JDK_HOME=${JDK_HOME#*/}
- JDK_HOME=${EPREFIX}/opt/${JDK_HOME%-r*}
- elif has_version --host-root dev-java/openjdk:${SLOT}; then
- JDK_HOME=${EPREFIX}/usr/$(get_libdir)/openjdk-${SLOT}
- elif has_version --host-root dev-java/openjdk-bin:${SLOT}; then
- JDK_HOME=$(best_version --host-root dev-java/openjdk-bin:${SLOT})
- JDK_HOME=${JDK_HOME#*/}
- JDK_HOME=${EPREFIX}/opt/${JDK_HOME%-r*}
- else
- die "Build VM not found!"
+ if [[ ${MERGE_TYPE} != binary ]]; then
+ if [[ -z ${JDK_HOME} ]]; then
+ for slot in ${SLOT} $((SLOT-1)); do
+ for variant in openj9- ''; do
+ if has_version --host-root dev-java/${variant}openjdk:${slot}; then
+ JDK_HOME=${EPREFIX}/usr/$(get_libdir)/${variant}openjdk-${slot}
+ break
+ elif has_version --host-root dev-java/${variant}openjdk-bin:${slot}; then
+ JDK_HOME=$(best_version --host-root dev-java/${variant}openjdk-bin:${slot})
+ JDK_HOME=${JDK_HOME#*/}
+ JDK_HOME=${EPREFIX}/opt/${JDK_HOME%-r*}
+ break
+ fi
+ done
+ done
fi
+ [[ -n ${JDK_HOME} ]] || die "Build VM not found!"
export JDK_HOME
fi
}
+src_unpack() {
+ if [[ ${OPENJ9_PV} == 9999 ]]; then
+ EGIT_CHECKOUT_DIR=${S} git-r3_src_unpack
+ EGIT_CHECKOUT_DIR=openj9 EGIT_REPO_URI=${OPENJ9_EGIT_REPO_URI} git-r3_src_unpack
+ EGIT_CHECKOUT_DIR=openj9-omr EGIT_REPO_URI=${OPENJ9_OMR_EGIT_REPO_URI} git-r3_src_unpack
+ else
+ default
+ fi
+}
+
src_prepare() {
- ln -s ../openj9-${OPENJ9_P} openj9 || die
- ln -s ../openj9-omr-${OPENJ9_P} omr || die
+ if [[ ${OPENJ9_PV} == 9999 ]]; then
+ ln -s ../openj9 openj9 || die
+ ln -s ../openj9-omr omr || die
+ else
+ ln -s ../openj9-${OPENJ9_P} openj9 || die
+ ln -s ../openj9-omr-${OPENJ9_P} omr || die
+ fi
default
eapply -d openj9 -- "${FILESDIR}/openj9-make-jvmti-test-variables-static.patch"
- # broken verifier
- #eapply -d openj9 -- "${FILESDIR}/openj9-j9utf8-fam.patch"
eapply -d omr -- "${FILESDIR}/omr-omrstr-iconv-failure-overflow.patch"
eapply -d omr -- "${FILESDIR}/omr-fam.patch"
- sed -i -e '/^OPENJ9_SHA :=/s/:=.*/:= '${OPENJ9_P}/ \
- -e '/^OPENJ9_TAG :=/s/:=.*/:= '${OPENJ9_P}/ \
- -e '/^OPENJ9OMR_SHA :=/s/:=.*/:= '${OPENJ9_P}/ \
- closed/OpenJ9.gmk
+ if [[ ${OPENJ9_PV} != 9999 ]]; then
+ sed -i -e '/^OPENJ9_SHA :=/s/:=.*/:= '${OPENJ9_P}/ \
+ -e '/^OPENJ9_TAG :=/s/:=.*/:= '${OPENJ9_P}/ \
+ -e '/^OPENJ9OMR_SHA :=/s/:=.*/:= '${OPENJ9_P}/ \
+ closed/OpenJ9.gmk
+ fi
chmod +x configure || die
}
@@ -174,7 +204,8 @@ src_configure() {
# Work around stack alignment issue, bug #647954. in case we ever have x86
use x86 && append-flags -mincoming-stack-boundary=2
- # Work around -fno-common ( GCC10 default ), bug #713180
+ # https://bugs.openjdk.java.net/browse/JDK-8249792
+ # not backported to 14?
append-flags -fcommon
if has_version dev-java/freemarker; then
@@ -246,7 +277,6 @@ src_compile() {
JOBS=$(makeopts_jobs)
# https://github.com/ibmruntimes/openj9-openjdk-jdk14/issues/72
#LOG=debug
- CFLAGS_WARNINGS_ARE_ERRORS= # No -Werror
$(usex doc docs '')
$(usex jbootstrap bootcycle-images product-images)
)
@@ -288,7 +318,7 @@ src_install() {
# must be done before running itself
java-vm_set-pax-markings "${ddest}"
- use gentoo-vm && java-vm_install-env "${FILESDIR}"/${PN}-${SLOT}.env.sh
+ use gentoo-vm && java-vm_install-env "${FILESDIR}"/${PN}.env.sh
java-vm_revdep-mask
java-vm_sandbox-predict /dev/random /proc/self/coredump_filter
diff --git a/dev-java/openj9-openjdk/openj9-openjdk-14.9999.ebuild b/dev-java/openj9-openjdk/openj9-openjdk-14.9999.ebuild
new file mode 100644
index 0000000..81fb828
--- /dev/null
+++ b/dev-java/openj9-openjdk/openj9-openjdk-14.9999.ebuild
@@ -0,0 +1,343 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+inherit autotools check-reqs flag-o-matic java-pkg-2 java-vm-2 multiprocessing pax-utils toolchain-funcs
+
+SLOT="$(get_major_version)"
+OPENJ9_PV="$(get_version_component_range 2-4)"
+OPENJ9_P=openj9-${OPENJ9_PV}
+FREEMARKER_PV=2.3.30
+
+DESCRIPTION="Open source implementation of the Java programming language"
+HOMEPAGE="https://openjdk.java.net"
+if [[ ${OPENJ9_PV} == 9999 ]]; then
+ inherit git-r3
+ EGIT_REPO_URI="https://github.com/ibmruntimes/openj9-openjdk-jdk${SLOT}.git"
+ OPENJ9_EGIT_REPO_URI="https://github.com/eclipse/openj9.git"
+ OPENJ9_OMR_EGIT_REPO_URI="https://github.com/eclipse/openj9-omr.git"
+else
+ SRC_URI="
+ https://github.com/ibmruntimes/openj9-openjdk-jdk${SLOT}/archive/${OPENJ9_P}.tar.gz -> openj9-openjdk-jdk${SLOT}-${OPENJ9_P}.tar.gz
+ https://github.com/eclipse/openj9/archive/${OPENJ9_P}.tar.gz -> ${OPENJ9_P}.tar.gz
+ https://github.com/eclipse/openj9-omr/archive/${OPENJ9_P}.tar.gz -> openj9-omr-${OPENJ9_PV}.tar.gz
+ "
+fi
+
+LICENSE="GPL-2"
+KEYWORDS=""
+
+IUSE="alsa cups ddr debug doc examples gentoo-vm headless-awt javafx +jbootstrap large-heap nsplugin +pch selinux source systemtap webstart"
+
+COMMON_DEPEND="
+ media-libs/freetype:2=
+ media-libs/giflib:0/7
+ media-libs/libpng:0=
+ media-libs/lcms:2=
+ sys-libs/zlib
+ virtual/jpeg:0=
+ systemtap? ( dev-util/systemtap )
+
+ dev-libs/elfutils
+ dev-libs/libdwarf
+ sys-process/numactl
+"
+
+# Many libs are required to build, but not to run, make is possible to remove
+# by listing conditionally in RDEPEND unconditionally in DEPEND
+RDEPEND="
+ ${COMMON_DEPEND}
+ >=sys-apps/baselayout-java-0.1.0-r1
+ !headless-awt? (
+ x11-libs/libX11
+ x11-libs/libXext
+ x11-libs/libXi
+ x11-libs/libXrandr
+ x11-libs/libXrender
+ x11-libs/libXt
+ x11-libs/libXtst
+ )
+ alsa? ( media-libs/alsa-lib )
+ cups? ( net-print/cups )
+ selinux? ( sec-policy/selinux-java )
+"
+
+DEPEND="
+ ${COMMON_DEPEND}
+ app-arch/zip
+ media-libs/alsa-lib
+ net-print/cups
+ x11-base/xorg-proto
+ x11-libs/libX11
+ x11-libs/libXext
+ x11-libs/libXi
+ x11-libs/libXrandr
+ x11-libs/libXrender
+ x11-libs/libXt
+ x11-libs/libXtst
+ javafx? ( dev-java/openjfx:${SLOT}= )
+ || (
+ virtual/jdk:${SLOT}
+ virtual/jdk:$((SLOT-1))
+ )
+ || (
+ dev-java/freemarker-bin
+ dev-java/freemarker
+ )
+"
+
+PDEPEND="
+ webstart? ( >=dev-java/icedtea-web-1.6.1:0 )
+ nsplugin? ( >=dev-java/icedtea-web-1.6.1:0[nsplugin] )
+"
+
+REQUIRED_USE="javafx? ( alsa !headless-awt )"
+
+if [[ ${OPENJ9_PV} == 9999 ]]; then
+ S="${WORKDIR}/openj9-openjdk-jdk${SLOT}"
+else
+ S="${WORKDIR}/openj9-openjdk-jdk${SLOT}-${OPENJ9_P}"
+fi
+
+# The space required to build varies wildly depending on USE flags,
+# ranging from 3GB to 16GB. This function is certainly not exact but
+# should be close enough to be useful.
+openjdk_check_requirements() {
+ local M
+ M=3192
+ M=$(( $(usex jbootstrap 2 1) * $M ))
+ M=$(( $(usex debug 3 1) * $M ))
+ M=$(( $(usex doc 320 0) + $(usex source 128 0) + 192 + $M ))
+
+ CHECKREQS_DISK_BUILD=${M}M check-reqs_pkg_${EBUILD_PHASE}
+}
+
+pkg_pretend() {
+ openjdk_check_requirements
+ if [[ ${MERGE_TYPE} != binary ]]; then
+ has ccache ${FEATURES} && die "FEATURES=ccache doesn't work with ${PN}"
+ fi
+}
+
+pkg_setup() {
+ openjdk_check_requirements
+ java-vm-2_pkg_setup
+
+ JAVA_PKG_WANT_BUILD_VM="openjdk-${SLOT} openjdk-bin-${SLOT}"
+ JAVA_PKG_WANT_SOURCE="${SLOT}"
+ JAVA_PKG_WANT_TARGET="${SLOT}"
+
+ # The nastiness below is necessary while the gentoo-vm USE flag is
+ # masked. First we call java-pkg-2_pkg_setup if it looks like the
+ # flag was unmasked against one of the possible build VMs. If not,
+ # we try finding one of them in their expected locations. This would
+ # have been slightly less messy if openjdk-bin had been installed to
+ # /opt/${PN}-${SLOT} or if there was a mechanism to install a VM env
+ # file but disable it so that it would not normally be selectable.
+
+ local vm
+ for vm in ${JAVA_PKG_WANT_BUILD_VM}; do
+ if [[ -d ${EPREFIX}/usr/lib/jvm/${vm} ]]; then
+ java-pkg-2_pkg_setup
+ return
+ fi
+ done
+
+ if [[ ${MERGE_TYPE} != binary ]]; then
+ if [[ -z ${JDK_HOME} ]]; then
+ for slot in ${SLOT} $((SLOT-1)); do
+ for variant in openj9- ''; do
+ if has_version --host-root dev-java/${variant}openjdk:${slot}; then
+ JDK_HOME=${EPREFIX}/usr/$(get_libdir)/${variant}openjdk-${slot}
+ break
+ elif has_version --host-root dev-java/${variant}openjdk-bin:${slot}; then
+ JDK_HOME=$(best_version --host-root dev-java/${variant}openjdk-bin:${slot})
+ JDK_HOME=${JDK_HOME#*/}
+ JDK_HOME=${EPREFIX}/opt/${JDK_HOME%-r*}
+ break
+ fi
+ done
+ done
+ fi
+ [[ -n ${JDK_HOME} ]] || die "Build VM not found!"
+ export JDK_HOME
+ fi
+}
+
+src_unpack() {
+ if [[ ${OPENJ9_PV} == 9999 ]]; then
+ EGIT_CHECKOUT_DIR=${S} git-r3_src_unpack
+ EGIT_CHECKOUT_DIR=openj9 EGIT_REPO_URI=${OPENJ9_EGIT_REPO_URI} git-r3_src_unpack
+ EGIT_CHECKOUT_DIR=openj9-omr EGIT_REPO_URI=${OPENJ9_OMR_EGIT_REPO_URI} git-r3_src_unpack
+ else
+ default
+ fi
+}
+
+src_prepare() {
+ if [[ ${OPENJ9_PV} == 9999 ]]; then
+ ln -s ../openj9 openj9 || die
+ ln -s ../openj9-omr omr || die
+ else
+ ln -s ../openj9-${OPENJ9_P} openj9 || die
+ ln -s ../openj9-omr-${OPENJ9_P} omr || die
+ fi
+
+ default
+
+ #einfo "Applying openj9-utf.patch"
+ #git -C openj9 apply -3 "${FILESDIR}/openj9-utf.patch" || die
+ eapply -d omr -- "${FILESDIR}/omr-omrstr-iconv-failure-overflow.patch"
+ eapply -d omr -- "${FILESDIR}/omr-fam.patch"
+
+ if [[ ${OPENJ9_PV} != 9999 ]]; then
+ sed -i -e '/^OPENJ9_SHA :=/s/:=.*/:= '${OPENJ9_P}/ \
+ -e '/^OPENJ9_TAG :=/s/:=.*/:= '${OPENJ9_P}/ \
+ -e '/^OPENJ9OMR_SHA :=/s/:=.*/:= '${OPENJ9_P}/ \
+ closed/OpenJ9.gmk
+ fi
+
+ chmod +x configure || die
+}
+
+src_configure() {
+ # Work around stack alignment issue, bug #647954. in case we ever have x86
+ use x86 && append-flags -mincoming-stack-boundary=2
+
+ if has_version dev-java/freemarker; then
+ local freemarker=freemarker
+ else
+ local freemarker=freemarker-bin
+ fi
+
+ # Enabling full docs appears to break doc building. If not
+ # explicitly disabled, the flag will get auto-enabled if pandoc and
+ # graphviz are detected. pandoc has loads of dependencies anyway.
+
+ local myconf=(
+ --disable-ccache
+ --enable-full-docs=no
+ --with-boot-jdk="${JDK_HOME}"
+ --with-extra-cflags="${CFLAGS}"
+ --with-extra-cxxflags="${CXXFLAGS}"
+ --with-extra-ldflags="${LDFLAGS}"
+ --with-stdc++lib=dynamic
+ --with-giflib=system
+ --with-lcms=system
+ --with-libjpeg=system
+ --with-libpng=system
+ --with-native-debug-symbols=$(usex debug internal none)
+ --with-vendor-name="Gentoo"
+ --with-vendor-url="https://gentoo.org"
+ --with-vendor-bug-url="https://bugs.gentoo.org"
+ --with-vendor-vm-bug-url="https://bugs.openjdk.java.net"
+ --with-vendor-version-string="${PVR}"
+ --with-version-pre=""
+ --with-version-opt=""
+ --with-zlib=system
+ --enable-dtrace=$(usex systemtap yes no)
+ --enable-headless-only=$(usex headless-awt yes no)
+
+ --with-freemarker-jar=$(java-pkg_getjar --build-only $freemarker freemarker.jar)
+ --disable-warnings-as-errors{,-omr,-openj9}
+ $(use_enable ddr)
+ $(use_with large-heap noncompressedrefs)
+ )
+
+ if use javafx; then
+ local zip="${EROOT%/}/usr/$(get_libdir)/openjfx-${SLOT}/javafx-exports.zip"
+ if [[ -r ${zip} ]]; then
+ myconf+=( --with-import-modules="${zip}" )
+ else
+ die "${zip} not found or not readable"
+ fi
+ fi
+
+ # PaX breaks pch, bug #601016
+ if use pch && ! host-is-pax; then
+ myconf+=( --enable-precompiled-headers )
+ else
+ myconf+=( --disable-precompiled-headers )
+ fi
+
+ (
+ unset _JAVA_OPTIONS JAVA JAVA_TOOL_OPTIONS JAVAC XARGS
+ CFLAGS= CXXFLAGS= LDFLAGS= \
+ CONFIG_SITE=/dev/null \
+ econf "${myconf[@]}"
+ )
+}
+
+src_compile() {
+ local myemakeargs=(
+ JOBS=$(makeopts_jobs)
+ # https://github.com/ibmruntimes/openj9-openjdk-jdk14/issues/72
+ #LOG=debug
+ $(usex doc docs '')
+ $(usex jbootstrap bootcycle-images product-images)
+ )
+ emake "${myemakeargs[@]}" -j1 #nowarn
+}
+
+src_install() {
+ local dest="/usr/$(get_libdir)/${PN}-${SLOT}"
+ local ddest="${ED}${dest#/}"
+
+ cd "${S}"/build/*-release/images/jdk || die
+
+ # Create files used as storage for system preferences.
+ mkdir .systemPrefs || die
+ touch .systemPrefs/.system.lock || die
+ touch .systemPrefs/.systemRootModFile || die
+
+ # Oracle and IcedTea have libjsoundalsa.so depending on
+ # libasound.so.2 but OpenJDK only has libjsound.so. Weird.
+ if ! use alsa ; then
+ rm -v lib/libjsound.* || die
+ fi
+
+ if ! use examples ; then
+ rm -vr demo/ || die
+ fi
+
+ if ! use source ; then
+ rm -v lib/src.zip || die
+ fi
+
+ rm -v lib/security/cacerts || die
+
+ dodir "${dest}"
+ cp -pPR * "${ddest}" || die
+
+ dosym ../../../../../etc/ssl/certs/java/cacerts "${dest}"/lib/security/cacerts
+
+ # must be done before running itself
+ java-vm_set-pax-markings "${ddest}"
+
+ use gentoo-vm && java-vm_install-env "${FILESDIR}"/${PN}.env.sh
+ java-vm_revdep-mask
+ java-vm_sandbox-predict /dev/random /proc/self/coredump_filter
+
+ if use doc ; then
+ docinto html
+ dodoc -r "${S}"/build/*-release/images/docs/*
+ dosym ../../../usr/share/doc/"${PF}" /usr/share/doc/"${PN}-${SLOT}"
+ fi
+}
+
+pkg_postinst() {
+ java-vm-2_pkg_postinst
+
+ if use gentoo-vm ; then
+ ewarn "WARNING! You have enabled the gentoo-vm USE flag, making this JDK"
+ ewarn "recognised by the system. This will almost certainly break"
+ ewarn "many java ebuilds as they are not ready for openjdk-11"
+ else
+ ewarn "The experimental gentoo-vm USE flag has not been enabled so this JDK"
+ ewarn "will not be recognised by the system. For example, simply calling"
+ ewarn "\"java\" will launch a different JVM. This is necessary until Gentoo"
+ ewarn "fully supports Java ${SLOT}. This JDK must therefore be invoked using its"
+ ewarn "absolute location under ${EPREFIX}/usr/$(get_libdir)/${PN}-${SLOT}."
+ fi
+}
diff --git a/dev-java/openj9-openjdk/openj9-openjdk-15.9999.ebuild b/dev-java/openj9-openjdk/openj9-openjdk-15.9999.ebuild
new file mode 100644
index 0000000..29ceae6
--- /dev/null
+++ b/dev-java/openj9-openjdk/openj9-openjdk-15.9999.ebuild
@@ -0,0 +1,341 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+inherit autotools check-reqs flag-o-matic java-pkg-2 java-vm-2 multiprocessing pax-utils toolchain-funcs
+
+SLOT="$(get_major_version)"
+OPENJ9_PV="$(get_version_component_range 2-4)"
+OPENJ9_P=openj9-${OPENJ9_PV}
+FREEMARKER_PV=2.3.30
+
+DESCRIPTION="Open source implementation of the Java programming language"
+HOMEPAGE="https://openjdk.java.net"
+if [[ ${OPENJ9_PV} == 9999 ]]; then
+ inherit git-r3
+ EGIT_REPO_URI="https://github.com/ibmruntimes/openj9-openjdk-jdk${SLOT}.git"
+ OPENJ9_EGIT_REPO_URI="https://github.com/eclipse/openj9.git"
+ OPENJ9_OMR_EGIT_REPO_URI="https://github.com/eclipse/openj9-omr.git"
+else
+ SRC_URI="
+ https://github.com/ibmruntimes/openj9-openjdk-jdk${SLOT}/archive/${OPENJ9_P}.tar.gz -> openj9-openjdk-jdk${SLOT}-${OPENJ9_P}.tar.gz
+ https://github.com/eclipse/openj9/archive/${OPENJ9_P}.tar.gz -> ${OPENJ9_P}.tar.gz
+ https://github.com/eclipse/openj9-omr/archive/${OPENJ9_P}.tar.gz -> openj9-omr-${OPENJ9_PV}.tar.gz
+ "
+fi
+
+LICENSE="GPL-2"
+KEYWORDS=""
+
+IUSE="alsa cups ddr debug doc examples gentoo-vm headless-awt javafx +jbootstrap large-heap nsplugin +pch selinux source systemtap webstart"
+
+COMMON_DEPEND="
+ media-libs/freetype:2=
+ media-libs/giflib:0/7
+ media-libs/libpng:0=
+ media-libs/lcms:2=
+ sys-libs/zlib
+ virtual/jpeg:0=
+ systemtap? ( dev-util/systemtap )
+
+ dev-libs/elfutils
+ dev-libs/libdwarf
+ sys-process/numactl
+"
+
+# Many libs are required to build, but not to run, make is possible to remove
+# by listing conditionally in RDEPEND unconditionally in DEPEND
+RDEPEND="
+ ${COMMON_DEPEND}
+ >=sys-apps/baselayout-java-0.1.0-r1
+ !headless-awt? (
+ x11-libs/libX11
+ x11-libs/libXext
+ x11-libs/libXi
+ x11-libs/libXrandr
+ x11-libs/libXrender
+ x11-libs/libXt
+ x11-libs/libXtst
+ )
+ alsa? ( media-libs/alsa-lib )
+ cups? ( net-print/cups )
+ selinux? ( sec-policy/selinux-java )
+"
+
+DEPEND="
+ ${COMMON_DEPEND}
+ app-arch/zip
+ media-libs/alsa-lib
+ net-print/cups
+ x11-base/xorg-proto
+ x11-libs/libX11
+ x11-libs/libXext
+ x11-libs/libXi
+ x11-libs/libXrandr
+ x11-libs/libXrender
+ x11-libs/libXt
+ x11-libs/libXtst
+ javafx? ( dev-java/openjfx:${SLOT}= )
+ || (
+ virtual/jdk:${SLOT}
+ virtual/jdk:$((SLOT-1))
+ )
+ || (
+ dev-java/freemarker-bin
+ dev-java/freemarker
+ )
+"
+
+PDEPEND="
+ webstart? ( >=dev-java/icedtea-web-1.6.1:0 )
+ nsplugin? ( >=dev-java/icedtea-web-1.6.1:0[nsplugin] )
+"
+
+REQUIRED_USE="javafx? ( alsa !headless-awt )"
+
+if [[ ${OPENJ9_PV} == 9999 ]]; then
+ S="${WORKDIR}/openj9-openjdk-jdk${SLOT}"
+else
+ S="${WORKDIR}/openj9-openjdk-jdk${SLOT}-${OPENJ9_P}"
+fi
+
+# The space required to build varies wildly depending on USE flags,
+# ranging from 3GB to 16GB. This function is certainly not exact but
+# should be close enough to be useful.
+openjdk_check_requirements() {
+ local M
+ M=3192
+ M=$(( $(usex jbootstrap 2 1) * $M ))
+ M=$(( $(usex debug 3 1) * $M ))
+ M=$(( $(usex doc 320 0) + $(usex source 128 0) + 192 + $M ))
+
+ CHECKREQS_DISK_BUILD=${M}M check-reqs_pkg_${EBUILD_PHASE}
+}
+
+pkg_pretend() {
+ openjdk_check_requirements
+ if [[ ${MERGE_TYPE} != binary ]]; then
+ has ccache ${FEATURES} && die "FEATURES=ccache doesn't work with ${PN}"
+ fi
+}
+
+pkg_setup() {
+ openjdk_check_requirements
+ java-vm-2_pkg_setup
+
+ JAVA_PKG_WANT_BUILD_VM="openjdk-${SLOT} openjdk-bin-${SLOT}"
+ JAVA_PKG_WANT_SOURCE="${SLOT}"
+ JAVA_PKG_WANT_TARGET="${SLOT}"
+
+ # The nastiness below is necessary while the gentoo-vm USE flag is
+ # masked. First we call java-pkg-2_pkg_setup if it looks like the
+ # flag was unmasked against one of the possible build VMs. If not,
+ # we try finding one of them in their expected locations. This would
+ # have been slightly less messy if openjdk-bin had been installed to
+ # /opt/${PN}-${SLOT} or if there was a mechanism to install a VM env
+ # file but disable it so that it would not normally be selectable.
+
+ local vm
+ for vm in ${JAVA_PKG_WANT_BUILD_VM}; do
+ if [[ -d ${EPREFIX}/usr/lib/jvm/${vm} ]]; then
+ java-pkg-2_pkg_setup
+ return
+ fi
+ done
+
+ if [[ ${MERGE_TYPE} != binary ]]; then
+ if [[ -z ${JDK_HOME} ]]; then
+ for slot in ${SLOT} $((SLOT-1)); do
+ for variant in openj9- ''; do
+ if has_version --host-root dev-java/${variant}openjdk:${slot}; then
+ JDK_HOME=${EPREFIX}/usr/$(get_libdir)/${variant}openjdk-${slot}
+ break
+ elif has_version --host-root dev-java/${variant}openjdk-bin:${slot}; then
+ JDK_HOME=$(best_version --host-root dev-java/${variant}openjdk-bin:${slot})
+ JDK_HOME=${JDK_HOME#*/}
+ JDK_HOME=${EPREFIX}/opt/${JDK_HOME%-r*}
+ break
+ fi
+ done
+ done
+ fi
+ [[ -n ${JDK_HOME} ]] || die "Build VM not found!"
+ export JDK_HOME
+ fi
+}
+
+src_unpack() {
+ if [[ ${OPENJ9_PV} == 9999 ]]; then
+ EGIT_CHECKOUT_DIR=${S} git-r3_src_unpack
+ EGIT_CHECKOUT_DIR=openj9 EGIT_REPO_URI=${OPENJ9_EGIT_REPO_URI} git-r3_src_unpack
+ EGIT_CHECKOUT_DIR=openj9-omr EGIT_REPO_URI=${OPENJ9_OMR_EGIT_REPO_URI} git-r3_src_unpack
+ else
+ default
+ fi
+}
+
+src_prepare() {
+ if [[ ${OPENJ9_PV} == 9999 ]]; then
+ ln -s ../openj9 openj9 || die
+ ln -s ../openj9-omr omr || die
+ else
+ ln -s ../openj9-${OPENJ9_P} openj9 || die
+ ln -s ../openj9-omr-${OPENJ9_P} omr || die
+ fi
+
+ default
+
+ eapply -d omr -- "${FILESDIR}/omr-omrstr-iconv-failure-overflow.patch"
+ eapply -d omr -- "${FILESDIR}/omr-fam.patch"
+
+ if [[ ${OPENJ9_PV} != 9999 ]]; then
+ sed -i -e '/^OPENJ9_SHA :=/s/:=.*/:= '${OPENJ9_P}/ \
+ -e '/^OPENJ9_TAG :=/s/:=.*/:= '${OPENJ9_P}/ \
+ -e '/^OPENJ9OMR_SHA :=/s/:=.*/:= '${OPENJ9_P}/ \
+ closed/OpenJ9.gmk
+ fi
+
+ chmod +x configure || die
+}
+
+src_configure() {
+ # Work around stack alignment issue, bug #647954. in case we ever have x86
+ use x86 && append-flags -mincoming-stack-boundary=2
+
+ if has_version dev-java/freemarker; then
+ local freemarker=freemarker
+ else
+ local freemarker=freemarker-bin
+ fi
+
+ # Enabling full docs appears to break doc building. If not
+ # explicitly disabled, the flag will get auto-enabled if pandoc and
+ # graphviz are detected. pandoc has loads of dependencies anyway.
+
+ local myconf=(
+ --disable-ccache
+ --enable-full-docs=no
+ --with-boot-jdk="${JDK_HOME}"
+ --with-extra-cflags="${CFLAGS}"
+ --with-extra-cxxflags="${CXXFLAGS}"
+ --with-extra-ldflags="${LDFLAGS}"
+ --with-stdc++lib=dynamic
+ --with-giflib=system
+ --with-lcms=system
+ --with-libjpeg=system
+ --with-libpng=system
+ --with-native-debug-symbols=$(usex debug internal none)
+ --with-vendor-name="Gentoo"
+ --with-vendor-url="https://gentoo.org"
+ --with-vendor-bug-url="https://bugs.gentoo.org"
+ --with-vendor-vm-bug-url="https://bugs.openjdk.java.net"
+ --with-vendor-version-string="${PVR}"
+ --with-version-pre=""
+ --with-version-opt=""
+ --with-zlib=system
+ --enable-dtrace=$(usex systemtap yes no)
+ --enable-headless-only=$(usex headless-awt yes no)
+
+ --with-freemarker-jar=$(java-pkg_getjar --build-only $freemarker freemarker.jar)
+ #--disable-warnings-as-errors{,-omr,-openj9}
+ $(use_enable ddr)
+ $(use_with large-heap noncompressedrefs)
+ )
+
+ if use javafx; then
+ local zip="${EROOT%/}/usr/$(get_libdir)/openjfx-${SLOT}/javafx-exports.zip"
+ if [[ -r ${zip} ]]; then
+ myconf+=( --with-import-modules="${zip}" )
+ else
+ die "${zip} not found or not readable"
+ fi
+ fi
+
+ # PaX breaks pch, bug #601016
+ if use pch && ! host-is-pax; then
+ myconf+=( --enable-precompiled-headers )
+ else
+ myconf+=( --disable-precompiled-headers )
+ fi
+
+ (
+ unset _JAVA_OPTIONS JAVA JAVA_TOOL_OPTIONS JAVAC XARGS
+ CFLAGS= CXXFLAGS= LDFLAGS= \
+ CONFIG_SITE=/dev/null \
+ econf "${myconf[@]}"
+ )
+}
+
+src_compile() {
+ local myemakeargs=(
+ JOBS=$(makeopts_jobs)
+ # https://github.com/ibmruntimes/openj9-openjdk-jdk14/issues/72
+ #LOG=debug
+ $(usex doc docs '')
+ $(usex jbootstrap bootcycle-images product-images)
+ )
+ emake "${myemakeargs[@]}" -j1 #nowarn
+}
+
+src_install() {
+ local dest="/usr/$(get_libdir)/${PN}-${SLOT}"
+ local ddest="${ED}${dest#/}"
+
+ cd "${S}"/build/*-release/images/jdk || die
+
+ # Create files used as storage for system preferences.
+ mkdir .systemPrefs || die
+ touch .systemPrefs/.system.lock || die
+ touch .systemPrefs/.systemRootModFile || die
+
+ # Oracle and IcedTea have libjsoundalsa.so depending on
+ # libasound.so.2 but OpenJDK only has libjsound.so. Weird.
+ if ! use alsa ; then
+ rm -v lib/libjsound.* || die
+ fi
+
+ if ! use examples ; then
+ rm -vr demo/ || die
+ fi
+
+ if ! use source ; then
+ rm -v lib/src.zip || die
+ fi
+
+ rm -v lib/security/cacerts || die
+
+ dodir "${dest}"
+ cp -pPR * "${ddest}" || die
+
+ dosym ../../../../../etc/ssl/certs/java/cacerts "${dest}"/lib/security/cacerts
+
+ # must be done before running itself
+ java-vm_set-pax-markings "${ddest}"
+
+ use gentoo-vm && java-vm_install-env "${FILESDIR}"/${PN}.env.sh
+ java-vm_revdep-mask
+ java-vm_sandbox-predict /dev/random /proc/self/coredump_filter
+
+ if use doc ; then
+ docinto html
+ dodoc -r "${S}"/build/*-release/images/docs/*
+ dosym ../../../usr/share/doc/"${PF}" /usr/share/doc/"${PN}-${SLOT}"
+ fi
+}
+
+pkg_postinst() {
+ java-vm-2_pkg_postinst
+
+ if use gentoo-vm ; then
+ ewarn "WARNING! You have enabled the gentoo-vm USE flag, making this JDK"
+ ewarn "recognised by the system. This will almost certainly break"
+ ewarn "many java ebuilds as they are not ready for openjdk-11"
+ else
+ ewarn "The experimental gentoo-vm USE flag has not been enabled so this JDK"
+ ewarn "will not be recognised by the system. For example, simply calling"
+ ewarn "\"java\" will launch a different JVM. This is necessary until Gentoo"
+ ewarn "fully supports Java ${SLOT}. This JDK must therefore be invoked using its"
+ ewarn "absolute location under ${EPREFIX}/usr/$(get_libdir)/${PN}-${SLOT}."
+ fi
+}